//VAʐMRg[

#include	<avr/io.h>
#include	<avr/pgmspace.h>
#include	"comctrl.h"

enum E_RCV_STATUS
{
	ST_READY,
	ST_GETDATA
};

static	uint8_t	rcvState;
static	uint8_t	rcvCommand;
static	uint8_t	rcvCount, hi4bit, lo4bit;

//Mobt@
static	uint8_t	rbuf[TOTAL_BUF_SIZE] = {0};
static	uint8_t	ridx;
uint8_t	*comGetDataBuf() { return &rbuf[CMD_BUF_SIZE]; }	//ʐMf[^obt@̐擪|C^Ԃ

//Q^'A'𗚂猳̐l0`15ɕϊ
#define	ctoi(c)	((c) - 'A')

//̉4bit̐l0`15ɃQ^'A'𗚂ĕɕϊ
#define itoc(n)	('A' + ((n) & 0x0F))

//USART̎Mobt@NA
void	comUsartRcvBufClear()
{
	uint8_t	dmy;
	while (UCSRA & (1 << RXC)) dmy = UDR;
}

//ʐMݒ
void	comInit()
{
	/*	ATtiny2313	VAʐM
	UCSRB:RXEN = 1:M		UCSRB:TXEN = 1:M
	UCSRB:UCSZ2,UCSRC:UCSZ1,UCSZ0 = 011:f[^8rbg
	UCSRC:UPM1,UPM0 = 00:peBȂ	UCSRC:USBS = 0:Xgbvrbg1rbg
	*/
	UBRRH	= 0;
	UBRRL	= F_CPU / 16 / COMCTRL_BAUD_RATE - 1;
	UCSRB	= (1 << RXEN) | (1 << TXEN) | (0 << UCSZ2);
	UCSRC	= (0 << UPM1) | (0 << UPM0) | (0 << USBS) | (1 << UCSZ1) | (1 << UCSZ0);
	
	comUsartRcvBufClear();
	rcvState = ST_READY;
}

//ʐMĎ^R}hf[^擾
//߂l
//ER}hM҂̏ԂłCOMCTRL_WAIT_RCVԂB
//ER}hMA
//		f[^M܂łCOMCTRL_WAIT_RCVԂB
//		f[^MAMR}hԂB
//Esȃf[^MȂǃG[COMCTRL_RET_UNKNOWN_CMDԂB
uint8_t	comPolling()
{
	uint8_t	byteData;
	
	//VAʐMM
	if (!(UCSRA & (1 << RXC))) return COMCTRL_WAIT_RCV;
	byteData = UDR;
	
	switch (rcvState)
	{
	case ST_READY:		//R}hM̑ҋ@
		//ȂIR[hMꍇiM̃~XB܂͏_ňӐ}IɑĂj
		if (byteData == COMCTRL_END_CODE)
		{
			return COMCTRL_RET_UNKNOWN_CMD;
		}
		
		//R}hM̂ƂāAf[^M̏
		rcvCommand = byteData;
		ridx = 0;
		rcvCount = 0;
		rcvState = ST_GETDATA;
		break;	//Ms
		
	case ST_GETDATA:	//f[^M
		//IR[hMꍇ
		if (byteData == COMCTRL_END_CODE)
		{
			//R}h̉
			if (COMCTRL_LCD_DATA <= rcvCommand && rcvCommand < COMCTRL_LCD_DATA + LCD_DATA_CHAR_LENGTH)
			{
				rbuf[ridx] = rcvCommand - COMCTRL_LCD_DATA + 1;
				rcvCommand = COMCTRL_LCD_DATA_RLEB;
			}
			
			rcvState = ST_READY;
			return rcvCommand;	//MR}hԂ
		}
		
		//obt@TCY𒴂f[^ʂMꍇiM̃~XB܂͒ʐMguj
		if (TOTAL_BUF_SIZE <= ridx)
		{
			rcvState = ST_READY;
			return COMCTRL_RET_UNKNOWN_CMD;		//ߕs\ȃR}h󂯎̂Ƃ
		}
		
		//Lȃf[^󂯎̂Ƃăobt@Ɋi[
		//f[^́A1byte̒lʁ^4bitɕAHƂđĂ
		if (rcvCount == 0)
		{
			hi4bit = ctoi(byteData);
			rcvCount = 1;
		}
		else
		{
			lo4bit = ctoi(byteData);
			rbuf[ridx++] = (hi4bit << 4) | lo4bit;
			rcvCount = 0;
		}
		break;	//Ms
		
	default:	break;
	}
	
	//R}hMAf[^M𑱍s
	return COMCTRL_WAIT_RCV;
}

//Mobt@(byte[0][1][2]...)̎wʒu擾
uint8_t	comGetByte(uint8_t idx)
{
	return rbuf[idx];
}

//Mobt@(byte[0][1][2]...)̎wʒuwordlƂĒl擾
uint16_t	comGetWord(uint8_t idx)
{
	uint16_t hiByte = (uint16_t)comGetByte(idx);
	uint16_t loByte = (uint16_t)comGetByte(idx + 1);
	return (hiByte << 8) | loByte;
}

//USART̑Mobt@1byteށizXg֑Mj
void	comSendByte(uint8_t data)
{
	while (!(UCSRA & (1 << UDRE))) {}	//Mobt@̋󂫑҂
	UDR = data;
}

//WHOR}hɑ΂ԐM
void	comSendMyName()
{
	const char *name = PSTR(COMCTRL_MY_NAME);
	uint8_t	c;
	while ((c = pgm_read_byte(name++)) != '\0') comSendByte(c);
}
