//	ATtiny2313
//	aitendo/NOKIA3300-LCD(S1D15G10) eXg
//	wt]xH쎺	http://jsdiy.web.fc2.com

/*
y|[gΉz	ATtiny2313	x:݂Ȃ(PA2RESET) -:
bit		7	6	5	4	3	2	1	0
portA	x	x	x	x	x	x	-	-		--
portB	SCL	SI	-	CS	-	-	-	-		LCD
portD	-	-	-	-	-	-	TXD	RXD		VAʐM

yATtiny2313z
|-BBBBBBBBD|
|V765432106|
>          |
|201102345G|
|ADDAADDDD-|

yq[Yrbgz(ftavrw.exe -rf)	Hoאݒ Low:01100100(64)
[vusb-20120109/examples/hid-data/firmware/Makefile]Q
Low: 11100100 (E4)
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:PD2ɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11-11111 (DF)
     |||||||+-- RSTDISBL (RESETs 1:L, 0:(PA2))
     ||||+++-- BODLEVEL[2:0] (111:Off, 110:1.8, 101:2.7, 100:4.3)
     |||+-- WDTON (WDT 0:펞ON, 1:ʏ)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
     |+-- EESAVE (EEPROM 1:, 0:ێ)
     +-- DWEN (On-ChipfobO 1:, 0:L)

Ext: -------1 (FF)
            +-- SPMEN (SPM 1:, 0:L)

yrhz
Atmel AVR Studio 5 (Version: 5.1.208)	œKIvV: -Os
AVRGCC Version: 3.3.1.27
ATtiny2313	8MHz Ȃ

yXVz
2012/05/09	v1.00	Program:     558 bytes (27.2% Full)
					Data:         11 bytes (8.6% Full)
*/

#include <avr/io.h>
#include <util/delay.h>
#include "comctrl.h"

#define USI_USCK	(1 << PB7)
#define USI_DO		(1 << PB6)
#define USI_DI		(1 << PB5)
#define LCD_CS		(1 << PB4)
#define LCD_SI		USI_DO
#define LCD_SCL		USI_USCK
#define LCD_CMD_BV	(0 << 7)	//When entering commands: SI = LOW at the rising edge of the 1st SCL.
#define LCD_DATA_BV	(1 << 7)	//When entering data (parameters): SI = HIGH at the rising edge of the 1st SCL.
#define lcdSetLo(bv)	{ PORTB &= ~(bv); }
#define lcdSetHi(bv)	{ PORTB |= (bv); }


//f[^ǂݏobt@
uint8_t *byteDatas;

//3^NbN̗ŃVtg{o͂^NbN̓\tgIɐ
#define USICR_CLKSRC_SELECT	((0 << USIWM1) | (1 << USIWM0) | (1 << USICS1) | (1 << USICS0) | (1 << USICLK))
#define USI_TOGGLE_CLKPIN	(USICR_CLKSRC_SELECT | (1 << USITC))
//
//USICR = (0 << USIWM1) | (1 << USIWM0) | (0 << USICS1) | (0 << USICS0) ̐ݒ肾ƁA
//1bitVtgčŌUSI_DI̓͒l⊮loBi샂[h0/1̈ႢHj
//) USIDR = 0b01010011; -> 0b1010011i
	

//LCD𑀍삷
//	bvType:		MeR}hAf[^ilMSBɃZbgĂj
//		byteValue:	R}hA܂́Af[^̎l
//E̊֐SCL=HȉԂŌĂяoƁB
static void	lcdCtrl(uint8_t bvType, uint8_t byteValue)
{
	uint8_t i;
	
	lcdSetLo(LCD_CS);
	
	//R}h^f[^̋1bit𑗏o
	USIDR = bvType;
	USICR = USI_TOGGLE_CLKPIN;	//SCL=Lo
	USICR = USI_TOGGLE_CLKPIN;	//SCL=Hi
	
	//R}h^f[^̎l8bit𑗏o
	USIDR = byteValue;
	for (i = 0; i < 8; i++)
	{
		USICR = USI_TOGGLE_CLKPIN;	//SCL=Lo
		USICR = USI_TOGGLE_CLKPIN;	//SCL=Hi
	}
	
	lcdSetHi(LCD_CS);
}

#if (0)	//USIgȂ@
static void	lcdCtrl(uint8_t bvType, uint8_t byteValue)
{
	uint8_t i, s;
	uint16_t bits = (bvType ? 0x0100 : 0x0000) | byteValue;
	
	lcdSetLo(LCD_CS);
	
	for (i = 0, s = 8; i < 9; i++, s--)
	{
		lcdSetLo(LCD_SCL);
		if ((bits >> s) & 1){ lcdSetHi(LCD_SI); } else { lcdSetLo(LCD_SI); }
		lcdSetHi(LCD_SCL);
	}
	
	lcdSetHi(LCD_CS);
}
#endif

int main(void)
{
	uint8_t		reqCommand, u8tmp;
	uint8_t		size, count;
	uint16_t	wsize, wcount;
	
	byteDatas = comGetDataBuf();
	comInit();
	
	DDRB = LCD_CS | LCD_SCL | LCD_SI;
	lcdSetHi(LCD_CS | LCD_SCL);
	
	while (1)
    {
		//R}h҂
		reqCommand = comPolling();
		if (!comCmdExec(reqCommand)) continue;
		
		//̐U蕪
		//Eǂݍ݌n͎擾f[^ԂB
		//E݌n͏̍}ƂĎg̃R}hԂB
		switch (reqCommand)
		{
		case COMCTRL_LCD_CMD:
			u8tmp = comGetByte(0);
			lcdCtrl(LCD_CMD_BV, u8tmp);
			comSendByte(COMCTRL_LCD_CMD);
			break;
			
		case COMCTRL_LCD_DATA_RLEB:
			u8tmp = comGetByte(0);
			size = comGetByte(1);
			for (count = 0; count < size; count++)
				lcdCtrl(LCD_DATA_BV, u8tmp);
			comSendByte(COMCTRL_LCD_DATA_RLEB);
			break;
			
		case COMCTRL_LCD_DATA_RLEW:
			u8tmp = comGetByte(0);
			wsize = comGetWord(1);
			for (wcount = 0; wcount < wsize; wcount++)
				lcdCtrl(LCD_DATA_BV, u8tmp);
			comSendByte(COMCTRL_LCD_DATA_RLEW);
			break;
			
		case COMCTRL_CMD_WHO:
			comSendMyName();
			break;
			
		default:	break;
		}
		
		//R}hɉMĂĂƂ
		comUsartRcvBufClear();
		
		//R}h̕ԐM
		comSendByte(COMCTRL_END_CODE);
		
	}	//<- end of while()
	
}
